VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form MainForm 
   Caption         =   "Machine Vision Template -VB"
   ClientHeight    =   5748
   ClientLeft      =   132
   ClientTop       =   420
   ClientWidth     =   4536
   LinkTopic       =   "Form1"
   ScaleHeight     =   444.548
   ScaleMode       =   0  'User
   ScaleWidth      =   1
   Begin VB.Frame PlaceHolder 
      Height          =   3132
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   3852
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   9360
      Top             =   0
      _ExtentX        =   677
      _ExtentY        =   677
      _Version        =   393216
   End
   Begin VB.Menu FILE 
      Caption         =   "File"
      Begin VB.Menu OpenM 
         Caption         =   "Open Media File"
      End
      Begin VB.Menu SelectC 
         Caption         =   "Select Capture Device"
      End
   End
   Begin VB.Menu Options 
      Caption         =   "Options"
      Begin VB.Menu SelectF 
         Caption         =   "Select Filter"
      End
   End
   Begin VB.Menu Start 
      Caption         =   "Start Camera"
   End
   Begin VB.Menu Stp 
      Caption         =   "Stop Camera"
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'directshow intrefaces
Dim g_objMC As IMediaControl  ' from the General Declarations section ...
Dim g_objVideoWindow As IVideoWindow
Dim g_objMediaControl As FilgraphManager
Dim g_objMediaPosition As IMediaPosition
Dim g_objBasicAudio  As IBasicAudio
Dim g_objBasicVideo As IBasicVideo2


Private Sub Form_Load()
    Start.Enabled = False
    Stp.Enabled = False
    transformFilter = 0
End Sub

Private Sub Form_Terminate()
    ReleaseObjects
End Sub

Private Sub ReleaseObjects()
' release the directshow interfaces
    Set g_objMC = Nothing
    Set g_objVideoWindow = Nothing
    Set g_objMediaControl = Nothing
    Set g_objMediaPosition = Nothing
    Set g_objBasicAudio = Nothing
    Set g_objBasicVideo = Nothing
End Sub

Private Sub OpenM_Click()
' open media file.

    On Error Resume Next
    
    Set g_objMC = Nothing
    Set g_objMC = New FilgraphManager  ' create the new filter graph

    ' Use the common File Open dialog to let the user select the input file.
    CommonDialog1.ShowOpen  ' user selects a source or filter graph
    If CommonDialog1.FileName = "" Then
        Exit Sub
    End If
        
    'add the transform filter if the user has selected one.
    If transformFilter > 0 Then
        Set g_objRegFilters = g_objMC.RegFilterCollection
        Dim filter As IRegFilterInfo
        ' find the selected filter and add it to the graph
        ' g_objRegFilters is the FilgraphManager object's RegFilterCollection property
        For Each filter In g_objRegFilters
            If filter.Name = SelectFilter.List1.Text Then  ' the selected filter?
                Dim f As IFilterInfo  ' yes
                filter.filter f  ' add to the filter graph, return IFilterInfo f
                Exit For
            End If
        Next filter
    End If
    
    ' call IMediaControl.RenderFile to add all filters and connect all pins.
    g_objMC.RenderFile (CommonDialog1.FileName)    ' Generates the complete graph.

    'get the directshow interfaces
    Set g_objBasicAudio = g_objMC
    Set g_objVideoWindow = g_objMC
    Set g_objMediaEvent = g_objMC
    Set g_objMediaPosition = g_objMC
        
    'set the output video window to placeholder
    MainForm.ScaleMode = 3
    g_objVideoWindow.Left = PlaceHolder.Left
    g_objVideoWindow.Top = PlaceHolder.Top
    
    PlaceHolder.Width = g_objVideoWindow.Width
    PlaceHolder.Height = g_objVideoWindow.Height
    g_objVideoWindow.Owner = MainForm.hWnd
    g_objVideoWindow.WindowStyle = CLng(&H46000000)
    
    'graph is complete - run it
    g_objMC.Run
End Sub

Private Sub SelectC_Click()
'Select capture device
    SelectCapture.Show
    Start.Enabled = True
End Sub

Private Sub SelectF_Click()
'Select transform filter
    SelectFilter.Show
End Sub

Private Sub ShowP_Click()

End Sub

Private Sub Start_Click()
'Start capture device that has been selected
    
    On Error Resume Next
    
    Me.Stp.Enabled = True
    Me.Start.Enabled = False
    ReleaseObjects
   
    Set g_objMC = New FilgraphManager  ' create the new filter graph
    Set g_objRegFilters = g_objMC.RegFilterCollection
        
    ' add transform filter if one has been selected
    If transformFilter > 0 Then
        Dim filter As IRegFilterInfo
        ' find the selected filter and add it to the graph
        ' g_objRegFilters is the FilgraphManager object's RegFilterCollection property
        For Each filter In g_objRegFilters
            If filter.Name = SelectFilter.List1.Text Then  ' the selected filter?
                Dim f As IFilterInfo  ' yes
                filter.filter f  ' add to the filter graph
                Exit For
            End If
        Next filter
    
    End If
    
    'now add the capture device filter
    Dim fsource As IFilterInfo
    Dim pinsource As IPinInfo
    For Each filter In g_objRegFilters
        If filter.Name = SelectCapture.List1.Text Then  ' the selected filter?
            filter.filter fsource  ' add to the filter graph
            Exit For
        End If
    Next filter
    
    ' find the capture pin on the filter...
    Dim pinlist As IAMCollection
    For Each pinsource In fsource.Pins
        If pinsource.Name = "Capture" Then
            'render it
            pinsource.Render
       End If
    Next pinsource
    


    'get the directshow interfaces
    Set g_objBasicAudio = g_objMC
    Set g_objVideoWindow = g_objMC
    Set g_objMediaEvent = g_objMC
    Set g_objMediaPosition = g_objMC
        
    'set the video window to the placeholder
    MainForm.ScaleMode = 3
      
    g_objVideoWindow.Left = PlaceHolder.Left
    g_objVideoWindow.Top = PlaceHolder.Top
    
    PlaceHolder.Width = g_objVideoWindow.Width
    PlaceHolder.Height = g_objVideoWindow.Height
    
    g_objVideoWindow.Owner = MainForm.hWnd
    g_objVideoWindow.WindowStyle = CLng(&H46000000)
    
    'and run it
    g_objMC.Run
 
End Sub

Private Sub Stp_Click()
'stop the video capture device
    Me.Start.Enabled = True
    Me.Stp.Enabled = False
    g_objMC.Stop
End Sub
