// CompSel.cpp : implementation file
//
// Machine vision Template Application
// This dialog box allows processing filter selection

#include "stdafx.h"
#include "[!output PROJECT_NAME].h"
#include "CompSel.h"
#include "[!output PROJECT_NAME]Dlg.h"

#include <dshow.h>

#include <commctrl.h>
#include <commdlg.h>
#include <stdio.h>
#include <tchar.h>
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompSel dialog


CCompSel::CCompSel(CWnd* pParent /*=NULL*/)
	: CDialog(CCompSel::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCompSel)
//	m_compsel = _T("");
	//}}AFX_DATA_INIT
}


void CCompSel::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompSel)
	DDX_Control(pDX, IDC_COMPSEL, m_listcomp);
	DDX_LBString(pDX, IDC_COMPSEL, m_compsel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompSel, CDialog)
	//{{AFX_MSG_MAP(CCompSel)
	ON_LBN_SELCHANGE(IDC_COMPSEL, OnSelchangeCompsel)
	ON_LBN_DBLCLK(IDC_COMPSEL, OnDblclkCompsel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompSel message handlers

BOOL CCompSel::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::DestroyWindow();
}

void CCompSel::OnSelchangeCompsel() 
{

	
}

BOOL CCompSel::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	SelectFilter();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
HRESULT CCompSel::SelectFilter()
{
	
    USES_CONVERSION;
	ICreateDevEnum *pSysDevEnum;

	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
    IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}

// Obtain a class enumerator for the user filter category.

	IEnumMoniker *pEnumCat = NULL;
	
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_LegacyAmFilterCategory, &pEnumCat, 0);
	
	if (hr == S_OK) 
	{
		// Enumerate the monikers.
	    IMoniker *pMoniker = NULL;
		ULONG cFetched;
		int idx=0;
	    while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
	        hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
		        (void **)&pPropBag);
			if (SUCCEEDED(hr))
	        {
		        // To retrieve the filter's friendly name, do the following:
			    VARIANT varName;
	            VariantInit(&varName);
		        hr = pPropBag->Read(L"FriendlyName", &varName, 0);

			    if (SUCCEEDED(hr))
	            {
					
					int idx = m_listcomp.AddString(W2A(varName.bstrVal));
					if (!strcmp(W2A(varName.bstrVal),m_compsel))
						m_listcomp.SetCurSel(idx);
			
			    }
				VariantClear(&varName);
	            //Remember to release pFilter later.
		        CHECK_RELEASE(pPropBag);
			}
			CHECK_RELEASE(pMoniker);
		}
	    CHECK_RELEASE(pEnumCat);
	}	
	CHECK_RELEASE(pSysDevEnum);
	return(S_OK);

}

void CCompSel::OnDblclkCompsel() 
{
	CDialog::OnOK();
}

void CCompSel::OnOK() 
{
	
	CDialog::OnOK();
}
