//! \file [!output PROJECT_NAME].cpp
//! \brief implementation of C[!output PROJECT_NAME] class.
// Machine vision Template Application

#include "stdafx.h"
#include <atlbase.h>
#include <shlobj.h>

#include "[!output PROJECT_NAME].h"
#include "[!output PROJECT_NAME]Dlg.h"
#include "apSel.h"
#include <initguid.h>


/////////////////////////////////////////////////////////////////////////////
// C[!output PROJECT_NAME]Dlg dialog routines
/////////////////////////////////////////////////////////////////////////////

//!InitDialog: Run at startup, initialisation Routines
BOOL C[!output PROJECT_NAME]Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	LoadDefaults();

	m_Menu.LoadMenu(IDR_MENU1);
	
	m_Menu.EnableMenuItem(IDD_STOP,MF_GRAYED|MF_BYCOMMAND);
	

	CDialog::SetMenu(&m_Menu);
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

    ////////////////////////////////////////////////////////////////////////
    //
    //  DirectShow-specific initialization code
    //
    ////////////////////////////////////////////////////////////////////////

    // Initialize COM
    CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
    
    // Initialize DirectShow interfaces
	m_pBld				= NULL;
	m_pGrB				= NULL;
	m_pMedC				= NULL;
	m_pMedE				= NULL;
	m_pMedS				= NULL;
	m_pMedP				= NULL;
	m_pBasV				= NULL;
	m_pBasA				= NULL;
	m_pVidW				= NULL;
	m_pFilter			= NULL;    
	m_captureFilter		= NULL;	
	dlgCapsel.m_pFilter	= NULL;

    
	// Initialize DirectShow and query for needed interfaces
    HRESULT hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC, 
                          IID_IGraphBuilder, (void **)&m_pGrB);
     hr = InitDirectShow();
    if(FAILED(hr))
    {
        FreeDirectShow();
        RetailOutput(TEXT("Failed to initialize DirectShow!  hr=0x%x\r\n"), hr);
        return FALSE;
    }

	
	return TRUE;  
}

// Run before filter graph created to initialise interfaces
HRESULT C[!output PROJECT_NAME]Dlg::InitDirectShow(void)
{
    HRESULT hr = S_OK;

    if (FAILED(hr))
        return hr;
    hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL,
        CLSCTX_INPROC, IID_ICaptureGraphBuilder2, 
        (void **)&m_pBld);
    if (SUCCEEDED(hr))
    {
		
        m_pBld->SetFiltergraph(m_pGrB);
    }

    if (FAILED(hr = m_pGrB->QueryInterface(IID_IMediaControl, (void **)&m_pMedC)))
        return hr;

    if (FAILED(hr = m_pGrB->QueryInterface(IID_IMediaSeeking, (void **)&m_pMedS)))
        return hr;

    if (FAILED(hr = m_pGrB->QueryInterface(IID_IMediaEventEx, (void **)&m_pMedE)))
        return hr;

    if (FAILED(hr = m_pGrB->QueryInterface(IID_IBasicAudio,   (void **)&m_pBasA)))
        return hr;
    if (FAILED(hr = m_pGrB->QueryInterface(IID_IMediaPosition,   (void **)&m_pMedP)))
        return hr;
    if (FAILED(hr = m_pGrB->QueryInterface(IID_IVideoWindow,   (void **)&m_pVidW)))
        return hr;
    if (FAILED(hr = m_pGrB->QueryInterface(IID_IBasicVideo,   (void **)&m_pBasV)))
        return hr;

    return S_OK;
}


// Run to close filter graph and release objects from memory
HRESULT C[!output PROJECT_NAME]Dlg::FreeDirectShow(void)
{

    HRESULT hr=S_OK;
	if (m_pMedC) m_pMedC->Stop();
    if (m_pMedE)
    {	
        hr = m_pMedE->SetNotifyWindow((OAHWND)NULL, 0, 0);
        CHECK_RELEASE(m_pMedE);
    }
	
	ReleaseObj();

    return hr;
}

// Print debug messages if required
void C[!output PROJECT_NAME]Dlg::RetailOutput(TCHAR *szFormat, ...)
{
#ifdef _DEBUG
    TCHAR szBuffer[1024];  // Large buffer for long filenames or URLs
    const size_t NUMCHARS = sizeof(szBuffer) / sizeof(szBuffer[0]);
    const int LASTCHAR = NUMCHARS - 1;

    // Format the input string
    va_list pArgs;
    va_start(pArgs, szFormat);

    // Use a bounded buffer size to prevent buffer overruns.  Limit count to
    // character size minus one to allow for a NULL terminating character.
    _vsntprintf(szBuffer, NUMCHARS - 1, szFormat, pArgs);
    va_end(pArgs);

    // Ensure that the formatted string is NULL-terminated
    szBuffer[LASTCHAR] = TEXT('\0');
//	MessageBox(szBuffer, TEXT("DX App"), MB_OK);
#endif
}

// Run just before window shuts down. 
BOOL C[!output PROJECT_NAME]Dlg::DestroyWindow() 
{
	
		SaveDefaults();
        FreeDirectShow();	
		
		CoUninitialize( );

	return CDialog::DestroyWindow();
}


// Message Handler
BOOL C[!output PROJECT_NAME]Dlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{

	switch (wParam) 
	{
		case IDD_SELECT:
			if (m_pGrB !=NULL)FreeDirectShow();	
			CHECK_RELEASE(m_captureFilter);
			dlgCapsel.m_capsel = m_capdev;
			dlgCapsel.m_pFilter=NULL;
			dlgCapsel.DoModal();
			m_capdev = dlgCapsel.m_capsel;				
			m_captureFilter = dlgCapsel.m_pFilter;
			
			break;
		case IDD_GO:
				m_Menu.EnableMenuItem(IDD_GO,MF_GRAYED|MF_BYCOMMAND);
				m_Menu.EnableMenuItem(IDD_STOP,MF_ENABLED|MF_BYCOMMAND);
				PlayCap();

			break;
		case IDD_OPEN:
			if (m_pGrB !=NULL)ReleaseObj();
			CHECK_RELEASE(m_captureFilter);
			PlayFile();
			break;
		case IDD_SELFILTER:
			FreeDirectShow();	
			dlgCompsel.m_compsel = m_processfilter;
			dlgCompsel.DoModal();
			m_processfilter = dlgCompsel.m_compsel;				

		case IDD_STOP:
				m_Menu.EnableMenuItem(IDD_STOP,MF_GRAYED|MF_BYCOMMAND);
				m_Menu.EnableMenuItem(IDD_GO,MF_ENABLED|MF_BYCOMMAND);

			FreeDirectShow();	
			break;
	}

	return CDialog::OnCommand(wParam, lParam);
}

// Run to release Directshow objects from memory. If this is not done correctly, memory leaks will occur
void C[!output PROJECT_NAME]Dlg::ReleaseObj()
{	
	CHECK_RELEASE(m_pFilter);
	CHECK_RELEASE(m_captureFilter);
    if(m_pVidW)
    {
        m_pVidW->put_Visible(OAFALSE);
        m_pVidW->put_Owner(NULL);
    }
	CHECK_RELEASE(m_pMedE);
    CHECK_RELEASE(m_pMedS);
    CHECK_RELEASE(m_pMedP);
    CHECK_RELEASE(m_pMedC);
    CHECK_RELEASE(m_pBasA);
    CHECK_RELEASE(m_pBasV);
    CHECK_RELEASE(m_pVidW);
	CHECK_RELEASE(m_pBld);


	CHECK_RELEASE(m_pGrB);
	
}

// Run to Open and render a file. If there is a filter name in m_processfilter, it will be added to the filter graph
HRESULT C[!output PROJECT_NAME]Dlg::PlayFile()
{
	USES_CONVERSION;
	HRESULT hr;
    WCHAR wFile[MAX_PATH];
    RECT rect;
    OPENFILENAME ofn;

    TCHAR  szFileName[_MAX_PATH];
    TCHAR  szBuffer[_MAX_PATH] ;


    // start with capture file as current file name
    szFileName[0] = 0;
    static BOOL bSetInitialDir = FALSE;

    szBuffer[_MAX_PATH-1] = 0;  // Null-terminate

    ZeroMemory(&ofn, sizeof(OPENFILENAME)) ;
    ofn.lStructSize   = sizeof(OPENFILENAME) ;
    ofn.hwndOwner     = m_hWnd ;
    ofn.lpstrFilter   =     TEXT("Video Files (*.avi; *.qt; *.mov; *.mpg; *.mpeg; *.m1v)\0*.avi; *.qt; *.mov; *.mpg; *.mpeg; *.m1v\0");
    ofn.nFilterIndex  = 0 ;
    ofn.lpstrFile     = szFileName;
    ofn.nMaxFile      =MAX_PATH ;
    ofn.lpstrFileTitle = NULL;
    ofn.lpstrTitle    = TEXT("Open Media File...");
    ofn.nMaxFileTitle = 0 ;
    ofn.lpstrInitialDir = szBuffer;
    ofn.Flags = OFN_HIDEREADONLY | OFN_NOREADONLYRETURN | OFN_PATHMUSTEXIST ;

    if (bSetInitialDir == FALSE)
    {
        ofn.lpstrInitialDir = TEXT("\\\0");
        bSetInitialDir = TRUE;
    }
    else
        ofn.lpstrInitialDir = NULL;

    if(!GetOpenFileName(&ofn))
    {
       // We didn't get a capture file 
        return FALSE;
    }

    wcsncpy(wFile, T2W(ofn.lpstrFile), NUMELMS(wFile)-1);
    wFile[MAX_PATH-1] = 0;

	//Initialise Directshow
    CHECK(CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, 
                         IID_IGraphBuilder, (void **)&m_pGrB));

	CHECK( InitDirectShow());

	
	// Find and insert the processing filter that the user selected
	m_pFilter= FindFilter(&CLSID_LegacyAmFilterCategory,m_processfilter);	
	if (m_pFilter)
	{
		CHECK(m_pGrB->AddFilter(m_pFilter,L"Process"));

	}
  
	// Render the file to screen
	CHECK(m_pGrB->RenderFile(wFile, NULL));
	

	//Change the window size to match the native video file size.
	LONG lHeight, lWidth;
    CHECK(m_pBasV->GetVideoSize(&lWidth, &lHeight));

    int nTitleHeight  = GetSystemMetrics(SM_CYCAPTION);
    int nBorderWidth  = GetSystemMetrics(SM_CXBORDER);
    int nBorderHeight = GetSystemMetrics(SM_CYBORDER);

    // Account for size of title bar and borders for exact match
    // of window client area to default video size
	 SetWindowPos(NULL, 0, 0, lWidth + 2*nBorderWidth,
            lHeight + nTitleHeight + 2*nBorderHeight,
            SWP_NOMOVE | SWP_NOOWNERZORDER);


	GetClientRect(&rect);
    CHECK(m_pVidW->SetWindowPosition(rect.left, rect.top, rect.right, rect.bottom));
	CHECK(m_pVidW->put_Owner((OAHWND)m_hWnd));
	CHECK(m_pVidW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN));


	//And run the filter graph
	CHECK(m_pMedC->Run());



	return S_OK;
}

// Call this function to render the selected input device
HRESULT C[!output PROJECT_NAME]Dlg::PlayCap()
{
    USES_CONVERSION;


	HRESULT hr;

	// Get the Filter for the selected capture device
	if (m_captureFilter == NULL) 
		BindDefault(0);
	if (m_captureFilter == NULL) 
		BindDefault(1);
	if (m_captureFilter == NULL) return(1);


	// Initialise Directshow 
    CHECK(CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, 
                         IID_IGraphBuilder, (void **)&m_pGrB));

	InitDirectShow();


	//add the capture filter to the filter graph
	CHECK(m_pGrB->AddFilter(m_captureFilter,L"Source"));
	
	//add the processing filter to the filter graph
	m_pFilter= FindFilter(&CLSID_LegacyAmFilterCategory,m_processfilter);	
	if (m_pFilter)
	{
		CHECK(m_pGrB->AddFilter(m_pFilter,L"Process"));

	}
	
	
	//render the stream to video renderer
	hr= m_pBld->RenderStream(&PIN_CATEGORY_CAPTURE,  &MEDIATYPE_Video, m_captureFilter, m_pFilter, NULL);

	
	//change the window size to match the native resolution of the capture device.
	LONG lHeight, lWidth;

    CHECK(m_pVidW->get_Width(&lWidth));
	CHECK(m_pVidW->get_Height(&lHeight));
    int nTitleHeight  = GetSystemMetrics(SM_CYCAPTION);
    int nBorderWidth  = GetSystemMetrics(SM_CXBORDER);
    int nBorderHeight = GetSystemMetrics(SM_CYBORDER);

    // Account for size of title bar and borders for exact match
    // of window client area to default video size
	SetWindowPos(NULL, 0, 0, lWidth + 2*nBorderWidth,
            lHeight + nTitleHeight + 2*nBorderHeight,
            SWP_NOMOVE | SWP_NOOWNERZORDER);

	RECT rect;
	GetClientRect(&rect);
    CHECK(m_pVidW->SetWindowPosition(rect.left, rect.top, rect.right, rect.bottom));
	CHECK(m_pVidW->put_Owner((OAHWND)m_hWnd));

	CHECK(m_pVidW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN));


	CHECK( m_pMedE->SetNotifyWindow((OAHWND)m_hWnd, WM_GRAPHNOTIFY, 0));


	//And hit play.
	CHECK(m_pMedC->Run());
    
	
	return S_OK;
}

// This function returns the filter interface for a given filter name
IBaseFilter * C[!output PROJECT_NAME]Dlg::FindFilter (CONST GUID * gui,LPCTSTR  InFilter)
{
    USES_CONVERSION;

	IBaseFilter * lpFilter = NULL;
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
    IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return NULL;
	}

// Obtain a class enumerator for the all filters.

	IEnumMoniker *pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(*gui, &pEnumCat, 0);
	if (hr == S_OK) 
	{
		// Enumerate the monikers.
	    IMoniker *pMoniker = NULL;
		ULONG cFetched;
		int idx=0;
	    while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
	        hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
		        (void **)&pPropBag);
			if (SUCCEEDED(hr))
	        {
		        // To retrieve the filter's friendly name, do the following:
			    VARIANT varName;
	            VariantInit(&varName);
		        hr = pPropBag->Read(L"FriendlyName", &varName, 0);

			    if (SUCCEEDED(hr))
	            {
					if (strcmp(W2A(varName.bstrVal),InFilter)==0)
					{

						hr = pMoniker->BindToObject(NULL, NULL, IID_IBaseFilter,(void**)&lpFilter);
						CHECK_RELEASE(pPropBag);
						CHECK_RELEASE(pMoniker);
						break;
					}
			    }
				VariantClear(&varName);
	            //Remember to release pFilter later.
		        CHECK_RELEASE(pPropBag);
				CHECK_RELEASE(pMoniker);
			}
		
		}
	    CHECK_RELEASE(pEnumCat);
	}	
	CHECK_RELEASE(pSysDevEnum);


	return lpFilter;
}


//This function returns a pin interface for a given pin name for a certain filter
IPin * C[!output PROJECT_NAME]Dlg::GetPin(IBaseFilter * lpFilter, LPSTR InPin)
{
    USES_CONVERSION;
    HRESULT hr;

    IEnumPins *pEnum = 0;
    if (SUCCEEDED(lpFilter->EnumPins(&pEnum)))
    {
        IPin *pPin = 0;
        while (hr = pEnum->Next(1, &pPin, 0), hr == S_OK)
        {
			PIN_INFO pininfo;
            hr = pPin->QueryPinInfo(&pininfo);
            if (FAILED(hr))
            {
                pPin->Release();
                pEnum->Release();
                return NULL; // Something strange happened.
            }
			LPSTR stt = W2A(pininfo.achName);
			if (! strcmp(stt, InPin))
			{
				pininfo.pFilter->Release();
                pEnum->Release();
                return pPin;
            }
			pininfo.pFilter->Release();
            pPin->Release();
        }
        pEnum->Release();
    }

	return NULL;
}

// Window process for notifications
LRESULT C[!output PROJECT_NAME]Dlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	USES_CONVERSION;
    LONG evCode, evParam1, evParam2;
    HRESULT hr=S_OK;


    switch (message)
    {
        case WM_GRAPHNOTIFY:	//The filter may notify the application in this manner
			if (!m_pMedE) break;
			
		    while(SUCCEEDED(m_pMedE->GetEvent(&evCode, (LONG_PTR *) &evParam1, 
                    (LONG_PTR *) &evParam2, 0)))					
			{
				switch (evCode)
				{
				case  EC_DEFINEMESSAGEHERE:					
						
					break;
				case EC_STREAM_CONTROL_STOPPED:
					
					break;
				}

				hr = m_pMedE->FreeEventParams(evCode, evParam1, evParam2);
			}
			

            break;
	}
	return CDialog::WindowProc(message, wParam, lParam);
}

// There is a Running Object Table accessible to Graphedt. this function adds the filter graph to the ROT 
// to allow viewing from Graphedit (Ctrl G)
HRESULT C[!output PROJECT_NAME]Dlg::AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) 
{
    IMoniker * pMoniker;
    IRunningObjectTable *pROT;
    if (FAILED(GetRunningObjectTable(0, &pROT))) {
        return E_FAIL;
    }
    WCHAR wsz[256];
    wsprintfW(wsz, L"FilterGraph %08x pid %08x", (DWORD_PTR)pUnkGraph, GetCurrentProcessId());
    HRESULT hr = CreateItemMoniker(L"!", wsz, &pMoniker);
    if (SUCCEEDED(hr)) {
        hr = pROT->Register(ROTFLAGS_REGISTRATIONKEEPSALIVE, pUnkGraph,
            pMoniker, pdwRegister);
        pMoniker->Release();
    }
    pROT->Release();
    return hr;
}
// And remove it too...
void C[!output PROJECT_NAME]Dlg::RemoveFromRot(DWORD pdwRegister)
{
    IRunningObjectTable *pROT;
    if (SUCCEEDED(GetRunningObjectTable(0, &pROT))) {
        pROT->Revoke(pdwRegister);
        pROT->Release();
    }
}

void C[!output PROJECT_NAME]Dlg::SaveDefaults()
{
}		
void C[!output PROJECT_NAME]Dlg::LoadDefaults()
{

}	

// Get the filter interface for the capture filter name
HRESULT C[!output PROJECT_NAME]Dlg::BindDefault(int mode)
{
    USES_CONVERSION;
	if (m_capdev.IsEmpty()&&!mode)return (1);

	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
    IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}


// Obtain a class enumerator for the video capture category.

	IEnumMoniker *pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumCat, 0);
	if (hr == S_OK) 
	{
		// Enumerate the monikers.
	    IMoniker *pMoniker = NULL;
		ULONG cFetched;
		int idx=0;
	    while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
	        hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
		        (void **)&pPropBag);
			if (SUCCEEDED(hr))
	        {
		        // To retrieve the filter's friendly name, do the following:
			    VARIANT varName;
	            VariantInit(&varName);
		        hr = pPropBag->Read(L"FriendlyName", &varName, 0);

			    if (SUCCEEDED(hr))
	            {
					if (!strcmp(W2A(varName.bstrVal),m_capdev)||mode)
					{
						hr = pMoniker->BindToObject(NULL, NULL, IID_IBaseFilter,
			                (void**)&m_captureFilter );
						CHECK_RELEASE(pPropBag);
						CHECK_RELEASE(pMoniker);
						break;
					}
			    }
				VariantClear(&varName);
	            //Remember to release pFilter later.
		        CHECK_RELEASE(pPropBag);
			}
			CHECK_RELEASE(pMoniker);
		}
	    CHECK_RELEASE(pEnumCat);
	}	
	CHECK_RELEASE(pSysDevEnum);
	return(S_OK);
}


// this function can be used to save the filter graph in Graphedit file format.
HRESULT C[!output PROJECT_NAME]Dlg::SaveGraphFile(IGraphBuilder *pGraph, WCHAR *wszPath) 
{
    const WCHAR wszStreamName[] = L"ActiveMovieGraph"; 
    HRESULT hr;
    
    IStorage *pStorage = NULL;
    hr = StgCreateDocfile(
        wszPath,
        STGM_CREATE | STGM_TRANSACTED | STGM_READWRITE | STGM_SHARE_EXCLUSIVE,
        0, &pStorage);
    if(FAILED(hr)) 
    {
        return hr;
    }

    IStream *pStream;
    hr = pStorage->CreateStream(
        wszStreamName,
        STGM_WRITE | STGM_CREATE | STGM_SHARE_EXCLUSIVE,
        0, 0, &pStream);
    if (FAILED(hr)) 
    {
        pStorage->Release();    
        return hr;
    }

    IPersistStream *pPersist = NULL;
    pGraph->QueryInterface(IID_IPersistStream, (void**)&pPersist);
    hr = pPersist->Save(pStream, TRUE);
    pStream->Release();
    pPersist->Release();
    if (SUCCEEDED(hr)) 
    {
        hr = pStorage->Commit(STGC_DEFAULT);
    }
    pStorage->Release();
    return hr;
}



// change the rendere size when the window size is changed

void C[!output PROJECT_NAME]Dlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	RECT rect;
	GetClientRect(&rect);
    if(m_pVidW)
	{
		m_pVidW->SetWindowPosition(rect.left, rect.top, rect.right, rect.bottom);
		m_pVidW->put_Owner((OAHWND)m_hWnd);
		m_pVidW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN);
	}
	
	
}

// Show the property page (if any) for teh processing filter
// you can do the same for the camera by replacing m_pfiter with m_captureFilter 
void C[!output PROJECT_NAME]Dlg::OnShowpropertypage() 
{
	if(!m_pFilter)return;
	EnableAutomation();
	USES_CONVERSION;
	ISpecifyPropertyPages *pProp;

	HRESULT  hr = m_pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
	
	if (SUCCEEDED(hr)) 
	{
		IUnknown *pFilterUnk;
		m_pFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);

		// Show the page. 
		CAUUID pages;
		pProp->GetPages(&pages);
		OleCreatePropertyFrame(
			m_hWnd,                   // Parent window
			0, 100,                   // Reserved
			T2W("Filter Properties"),     // Caption for the dialog box
			1,                      // Number of objects (just the filter)
			&pFilterUnk,            // Array of object pointers. 
			pages.cElems,          // Number of property pages
			pages.pElems,          // Array of property page CLSIDs
			0,                      // Locale identifier
			0, NULL                 // Reserved
		);

		// Clean up.
		CHECK_RELEASE(pFilterUnk);		
		CoTaskMemFree(pages.pElems);
		return ;
	}
	
	CHECK_RELEASE(pProp);

}
C[!output PROJECT_NAME]Dlg::C[!output PROJECT_NAME]Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(C[!output PROJECT_NAME]Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(C[!output PROJECT_NAME]Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pVidW=NULL;
}

void C[!output PROJECT_NAME]Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(C[!output PROJECT_NAME]Dlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(C[!output PROJECT_NAME]Dlg, CDialog)
	//{{AFX_MSG_MAP(C[!output PROJECT_NAME]Dlg)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDD_SHOWPROPERTYPAGE, OnShowpropertypage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C[!output PROJECT_NAME]Dlg message handlers
