// apSel.cpp : implementation file
//
// Machine vision Template Application


#include "stdafx.h"
#include "[!output PROJECT_NAME].h"
#include "apSel.h"
#include "[!output PROJECT_NAME]Dlg.h"


#include <dshow.h>

#include <commctrl.h>
#include <commdlg.h>
#include <stdio.h>
#include <tchar.h>
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CapSel dialog
// this dialog box allows capture device selection
/////////////////////////////////////////////////////////////////////////////

CapSel::CapSel(CWnd* pParent /*=NULL*/)
	: CDialog(CapSel::IDD, pParent)
{
	//{{AFX_DATA_INIT(CapSel)
//	m_capsel = _T("");
	//}}AFX_DATA_INIT
}


void CapSel::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CapSel)
	DDX_Control(pDX, IDC_CAPSEL, m_listcap);
	DDX_LBString(pDX, IDC_CAPSEL, m_capsel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CapSel, CDialog)
	//{{AFX_MSG_MAP(CapSel)
	ON_LBN_SELCHANGE(IDC_CAPSEL, OnSelchangeCapsel)
	ON_LBN_DBLCLK(IDC_CAPSEL, OnDblclkCapsel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CapSel message handlers

BOOL CapSel::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	if (m_pFilter != NULL)CHECK_RELEASE(m_pFilter);
	for (int idx=0;idx<11;idx++)
	{
		m_array[idx]=NULL;
	}
    CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	SelectDevice();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


HRESULT CapSel::SelectDevice()
{
    USES_CONVERSION;



	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
    IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}

// Obtain a class enumerator for the video capture category.

	IEnumMoniker *pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumCat, 0);
	if (hr == S_OK) 
	{
		// Enumerate the monikers.
	    IMoniker *pMoniker = NULL;
		ULONG cFetched;
		int idx=0;
	    while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
	        hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
		        (void **)&pPropBag);
			if (SUCCEEDED(hr))
	        {
		        // To retrieve the filter's friendly name, do the following:
			    VARIANT varName;
	            VariantInit(&varName);
		        hr = pPropBag->Read(L"FriendlyName", &varName, 0);

			    if (SUCCEEDED(hr))
	            {
					m_listcap.AddString(W2A(varName.bstrVal));
					if (!strcmp(W2A(varName.bstrVal),m_capsel))
						m_listcap.SetCurSel(m_listcap.GetCount()-1);

            hr = pMoniker->BindToObject(NULL, NULL, IID_IBaseFilter,
                (void**)&(m_array[idx++]));

				
			    }
				VariantClear(&varName);
	            //Remember to release pFilter later.
		        CHECK_RELEASE(pPropBag);
			}
			CHECK_RELEASE(pMoniker);
		}
	    CHECK_RELEASE(pEnumCat);
	}	
	CHECK_RELEASE(pSysDevEnum);
	return(S_OK);
}

void CapSel::OnSelchangeCapsel() 
{
	// TODO: Add your control notification handler code here
	m_listidx = m_listcap.GetCurSel();
	
	m_listcap.GetText(m_listidx,m_capsel);
	m_pFilter = m_array[m_listidx];
	 

}


BOOL CapSel::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	for (int idx=0;idx<11;idx++)
	{
		if (m_array[idx] != NULL &&
			idx != m_listidx) CHECK_RELEASE(m_array[idx]);
	}	
	return CDialog::DestroyWindow();
}


void CapSel::OnDblclkCapsel() 
{
	CDialog::OnOK();
	
}
