
function OnFinish(selProj, selObj)
{
	try
	{
		var strProjectPath = wizard.FindSymbol('PROJECT_PATH');
		var strProjectName = wizard.FindSymbol('PROJECT_NAME');
		var strBasePath = wizard.FindSymbol('IDC_BASE');
		var strRawGUID = wizard.CreateGuid();
		var strFormattedGUID = wizard.FormatGuid(strRawGUID, 1);
		wizard.AddSymbol("APP_CLSID", strFormattedGUID);
		strRawGUID = wizard.CreateGuid();
		strFormattedGUID = wizard.FormatGuid(strRawGUID, 1);
		wizard.AddSymbol("APP_CLSID1", strFormattedGUID);
		strRawGUID = wizard.CreateGuid();
		strFormattedGUID = wizard.FormatGuid(strRawGUID, 1);
		wizard.AddSymbol("APP_IID", strFormattedGUID);

		selProj = CreateCustomProject(strProjectName, strProjectPath);
		
		AddConfig(selProj, strProjectName,strBasePath,strProjectPath);
//		AddFilters(selProj);

		var InfFile = CreateCustomInfFile();
		AddFilesToCustomProj(selProj, strProjectName, strProjectPath, InfFile);		
		PchSettings(selProj);
		InfFile.Delete();

		selProj.Object.Save();
	}
	catch(e)
	{
		if (e.description.length != 0)
			SetErrorInfo(e);
		return e.number
	}
}

function CreateCustomProject(strProjectName, strProjectPath)
{
	try
	{
		var strProjTemplatePath = wizard.FindSymbol('PROJECT_TEMPLATE_PATH');
		var strProjTemplate = '';
		strProjTemplate = strProjTemplatePath + '\\default.vcproj';

		var Solution = dte.Solution;
		var strSolutionName = "";
		if (wizard.FindSymbol("CLOSE_SOLUTION"))
		{
			Solution.Close();
			strSolutionName = wizard.FindSymbol("VS_SOLUTION_NAME");
			if (strSolutionName.length)
			{
				var strSolutionPath = strProjectPath.substr(0, strProjectPath.length - strProjectName.length);
				Solution.Create(strSolutionPath, strSolutionName);
			}
		}

		var strProjectNameWithExt = '';
		strProjectNameWithExt = strProjectName + '.vcproj';

		var oTarget = wizard.FindSymbol("TARGET");
		var prj;
		if (wizard.FindSymbol("WIZARD_TYPE") == vsWizardAddSubProject)  // vsWizardAddSubProject
		{
			var prjItem = oTarget.AddFromTemplate(strProjTemplate, strProjectNameWithExt);
			prj = prjItem.SubProject;
		}
		else
		{
			prj = oTarget.AddFromTemplate(strProjTemplate, strProjectPath, strProjectNameWithExt);
		}
		return prj;
	}
	catch(e)
	{
		throw e;
	}
}

function AddFilters(proj)
{
	try
	{
		// Add the folders to your project
        var strSrcFilter1 =  ".cpp;.cxx;.c";
//wizard.FindSymbol('SOURCE_FILTER');
        var strSrcFilter2 =  ".hpp;.h";
//wizard.FindSymbol('HEADER_FILTER');
        var strSrcFilter3 = ".rc";//wizard.FindSymbol('RESOURCE_FILTER');
        
        var group1 = proj.Object.AddFilter('Source Files');
        var group2 = proj.Object.AddFilter('Header Files');
        var group3 = proj.Object.AddFilter('Resource Files');
        
        group1.Filter = strSrcFilter1;
        
        group2.Filter = strSrcFilter2;
        group3.Filter = strSrcFilter3;
	}
	catch(e)
	{
		throw e;
	}
}

function AddConfig(proj, strProjectName,strBasePath,strProjectPath)
{
	try
	{
		var config = proj.Object.Configurations('Debug');
		config.IntermediateDirectory = 'Debug';
		config.OutputDirectory = 'Debug';
		config.ConfigurationType = ConfigurationTypes.typeDynamicLibrary

		var CLTool = config.Tools('VCCLCompilerTool');				
        CLTool.PreprocessorDefinitions = "WIN32,_DEBUG,_WINDOWS,_WIN32_WINNT=0x400";
		CLTool.DebugInformationFormat=debugOption.debugEnabled;
		CLTool.Optimization = optimizeOption.optimizeDisabled;
		CLTool.RuntimeLibrary=runtimeLibraryOption.rtMultiThreadedDebugDLL;        
        CLTool.UsePrecompiledHeader=pchOption.pchGenerateAuto;
        CLTool.PrecompiledHeaderThrough="stdafx.h";
		CLTool.PrecompiledHeaderFile=".\\Debug/"+strProjectName+".pch";
		CLTool.AssemblerListingLocation=".\\Debug\\";
		CLTool.CompileAs="0";
		CLTool.AdditionalIncludeDirectories = strBasePath;		
		
	//	var CBTool=config.Tools('VCCustomBuildTool');
	//	CBTool.Description="Register";
	//	CBTool.CommandLine="regsvr32 /c \""+strProjectPath+"\\Debug\\"+strProjectName+".ax\"";
	//	CBTool.Outputs="a.out"
        
		var LinkTool = config.Tools('VCLinkerTool');
		// TODO: Add linker settings
		LinkTool.AdditionalDependencies = "kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib winmm.lib "+strBasePath+"\\debug\\strmbasd.lib vtlibd.lib";
		LinkTool.OutputFile = "Debug\\"+strProjectName+".ax";
		LinkTool.ImportLibrary = "Debug\\"+strProjectName+".lib";
		LinkTool.ModuleDefinitionFile = ".\\"+strProjectName+".def";
		LinkTool.EntryPointSymbol = "DllEntryPoint@12";
		LinkTool.LinkDLL = true;
		LinkTool.GenerateDebugInformation = true;
		LinkTool.RegisterOutput = true;	

		config = proj.Object.Configurations('Release');
		config.IntermediateDirectory = 'Release';
		config.OutputDirectory = 'Release';

		var CLTool = config.Tools('VCCLCompilerTool');
      CLTool.PreprocessorDefinitions = "WIN32,_WINDOWS,_WIN32_WINNT=0x400";
		CLTool.DebugInformationFormat=debugOption.debugDisabled;
		CLTool.Optimization = optimizeOption.optimizeMaxSpeed;
		CLTool.RuntimeLibrary=runtimeLibraryOption.rtMultiThreadedDLL;        
        CLTool.UsePrecompiledHeader=pchOption.pchGenerateAuto;
        CLTool.PrecompiledHeaderThrough="stdafx.h";
		CLTool.PrecompiledHeaderFile=".\\Release/"+strProjectName+".pch";
		CLTool.CompileAs="0";
		CLTool.AdditionalIncludeDirectories = strBasePath;		
					
		var LinkTool = config.Tools('VCLinkerTool');
		LinkTool.AdditionalDependencies = "kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib winmm.lib "+strBasePath+"\\release\\strmbase.lib vtlib.lib";
		LinkTool.OutputFile = "release\\"+strProjectName+".ax";
		LinkTool.ImportLibrary = "release\\"+strProjectName+".lib";
		LinkTool.ModuleDefinitionFile = ".\\"+strProjectName+".def";
		LinkTool.EntryPointSymbol = "DllEntryPoint@12";
		LinkTool.LinkDLL = true;
		LinkTool.RegisterOutput = true;
		LinkTool.GenerateDebugInformation = false;
	}
	catch(e)
	{
		throw e;
	}
}

function PchSettings(proj)
{
	// TODO: specify pch settings
}

function DelFile(fso, strWizTempFile)
{
	try
	{
		if (fso.FileExists(strWizTempFile))
		{
			var tmpFile = fso.GetFile(strWizTempFile);
			tmpFile.Delete();
		}
	}
	catch(e)
	{
		throw e;
	}
}

function CreateCustomInfFile()
{
	try
	{
		var fso, TemplatesFolder, TemplateFiles, strTemplate;
		fso = new ActiveXObject('Scripting.FileSystemObject');

		var TemporaryFolder = 2;
		var tfolder = fso.GetSpecialFolder(TemporaryFolder);
		var strTempFolder = tfolder.Drive + '\\' + tfolder.Name;

		var strWizTempFile = strTempFolder + "\\" + fso.GetTempName();

		var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');
		var strInfFile = strTemplatePath + '\\Templates.inf';
		wizard.RenderTemplate(strInfFile, strWizTempFile);

		var WizTempFile = fso.GetFile(strWizTempFile);
		return WizTempFile;
	}
	catch(e)
	{
		throw e;
	}
}

function GetTargetName(strName, strProjectName)
{
	try
	{
		// TODO: set the name of the rendered file based on the template filename
		var strTarget = strName;
		if (strName == 'stdafx.h')
			strTarget = 'stdafx.h';			
		if (strName == 'stdafx.cpp')
			strTarget = 'stdafx.cpp';			
		if (strName == 'root.cpp')
			strTarget = strProjectName + ".cpp";
		if (strName == 'root.h')
			strTarget = strProjectName + ".h";			
		if (strName == 'root.def')
			strTarget = strProjectName + ".def";					
		if (strName == 'resource.h')
			strTarget = 'resource.h';
		if (strName == 'root.rc')
			strTarget = strProjectName + ".rc";			

		return strTarget; 
	}
	catch(e)
	{
		throw e;
	}
}

function AddFilesToCustomProj(proj, strProjectName, strProjectPath, InfFile)
{
	try
	{
		var projItems = proj.ProjectItems

		var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');

		var strTpl = '';
		var strName = '';

		var strTextStream = InfFile.OpenAsTextStream(1, -2);
		while (!strTextStream.AtEndOfStream)
		{
			strTpl = strTextStream.ReadLine();
			if (strTpl != '')
			{
				strName = strTpl;
				var strTarget = GetTargetName(strName, strProjectName);
				var strTemplate = strTemplatePath + '\\' + strTpl;
				var strFile = strProjectPath + '\\' + strTarget;

				var bCopyOnly = false;  //"true" will only copy the file from strTemplate to strTarget without rendering/adding to the project
				var strExt = strName.substr(strName.lastIndexOf("."));
				if(strExt==".bmp" || strExt==".ico" || strExt==".gif" || strExt==".rtf" || strExt==".css")
					bCopyOnly = true;
				wizard.RenderTemplate(strTemplate, strFile, bCopyOnly);
				proj.Object.AddFile(strFile);
			}
		}
		strTextStream.Close();
	}
	catch(e)
	{
		throw e;
	}
}
