//! \file [!output PROJECT_NAME].cpp
//! \brief implementation of C[!output PROJECT_NAME] class.
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "[!output PROJECT_NAME].h"



//! Initialise routine. 
/** This routine is called automatically on the creation of the filter in
  * in the filter graph. 
*/
HRESULT C[!output PROJECT_NAME]::InitVars(void) 
{
	//initialise any variables here
	
	//	the following are predefined:
	// 
	//  xImage	(# of cols)
	//	yImage	(# of rows)
	//	nPixel	(bytes per pixel - generally 24)
	//	nRow	(bytes per row)
	//	gSrcSize (bytes per frame)

	// so for example, a backup image space would be
	// pBackup=( BYTE*)malloc(gSrcSize);
	// 
	//	and 'BYTE * pBackup;' is defined as a class member
	

	CopyFrame=false;
	//set CopyFrame to true for OutData to be initialised with a copy of InData
	//set false otherwise
	
	FrameCnt=0;
	m_DibSection=NULL;
	return S_OK;
}

//! The main Transformation process run on a per frame basis
/** This routine is called once per frame. The data is transformed
* from the Input area - the image space starting at pInData, to 
* the output area pOutData
*/
HRESULT C[!output PROJECT_NAME]::TransformFrame(BYTE * pInData, BYTE * pOutData) 
{

	//Do your process here

	for (int x=0;x<xImage;x++)		//loop around the columns
	{
		for (int y=0;y<yImage;y++)	//process every row in the current column
		{
			//Call setpix to set a pixel value at a particular x,y coordinate in the image
			SetPix(pOutData,x,y,GetR(pInData,x,y),GetG(pInData,x,y),GetB(pInData,x,y));
			
			//note that you can alter poutdata directly if you wish. eg
			// *(pOutData + x*nPixel + y*nRow+0) =*(pOutData + x*nPixel + y*nRow+0) //Blue channel copy
			// *(pOutData + x*nPixel + y*nRow+1) =*(pOutData + x*nPixel + y*nRow+1) //Green channel copy
			// *(pOutData + x*nPixel + y*nRow+2) =*(pOutData + x*nPixel + y*nRow+2) //Red channel copy

			
		}
	}

	//Overlay some text onto the image
	Overlay(pOutData,"Overlay text here");
	return S_OK;
}

//! This routine sets the value in x,y pixel to colour(R,G,b)
void C[!output PROJECT_NAME]::SetPix(BYTE * pDestData,int x,int y,int r,int g,int b)
{
	BYTE * pBGR=pDestData+y*nRow+x*nPixel;

	*pBGR=b;			//blue channel is first
	*(pBGR+1)=g;		//then green
	*(pBGR+2)=r;		//then red
}

//! Return the intensity of the blue channel at (x,y)
short C[!output PROJECT_NAME]::GetB(BYTE * pSrc,int x,int y)
{
	return *(pSrc+y*nRow+x*nPixel);			//blue channel is first
}

//! Return the intensity of the red channel at (x,y)
short C[!output PROJECT_NAME]::GetR(BYTE * pSrc,int x,int y)
{
	return *(pSrc+y*nRow+x*nPixel+2);		//red channel is +2
}

//! Return the intensity of the green channel at (x,y)
short C[!output PROJECT_NAME]::GetG(BYTE * pSrc,int x,int y)
{
	return *(pSrc+y*nRow+x*nPixel+1);		//green channel is +1
}


///////////////////////////////////////////////////////////////////////
// C[!output PROJECT_NAME]: Constructor
///////////////////////////////////////////////////////////////////////
C[!output PROJECT_NAME]::C[!output PROJECT_NAME](TCHAR *tszName, LPUNKNOWN punk, HRESULT *phr)
    :	CvtFilter(tszName,punk, CLSID_[!output PROJECT_NAME])
{
}

///////////////////////////////////////////////////////////////////////
// ~C[!output PROJECT_NAME]: Destructor
///////////////////////////////////////////////////////////////////////
C[!output PROJECT_NAME]::~C[!output PROJECT_NAME]()
{
	
	//free any globals you malloc'd
}

  



