// [!output PROJECT_NAME].h: interface for the C[!output PROJECT_NAME] class.
// 
//////////////////////////////////////////////////////////////////////
//  C[!output PROJECT_NAME]: (A DirectShow filter)
//
//  Purpose: This filter is a basic Transform Filter to process video
//        
//  Usage: 
//  1.  Register the filter. 
//      regsvr32 [!output PROJECT_NAME].ax
//
//  2.  Insert the filter into the graph to process video data (live 
//      capture or video files)
//      a.  Use the GraphEdt.exe (in DirectX SDK) to build a graph 
//      b.  Use MVTemplateApp AppWizard to generate a directshow application
///////////////////////////////////////////////////////////////////////
#pragma once



#include <streams.h>     // DirectShow
#include <initguid.h>    // DEFINE_GUID to declare an EXTERN_C const.
#include <stdio.h>
#include <tchar.h>
#include <vtdxf.h>


DEFINE_GUID(CLSID_[!output PROJECT_NAME],[!output APP_CLSID]);
DEFINE_GUID(IID_I[!output PROJECT_NAME], [!output APP_CLSID1]);


class C[!output PROJECT_NAME]:
	public CvtFilter
{
public:

	    DECLARE_IUNKNOWN;


    static CUnknown *WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);

	C[!output PROJECT_NAME]::C[!output PROJECT_NAME](TCHAR *tszName, LPUNKNOWN punk, HRESULT *phr);
	~C[!output PROJECT_NAME]();
	
	 HRESULT InitVars(void) ;
	 HRESULT TransformFrame(BYTE * pInData, BYTE * pOutData) ;
	 HRESULT Overlay(BYTE *pDestData,LPSTR Str);
	void SetPix(BYTE *,int x,int y,int r,int g, int b);
	short GetB(BYTE *,int x,int y);
	short GetG(BYTE *,int x,int y);
	short GetR(BYTE *,int x,int y);
    HBITMAP     m_DibSection;
    HDC         m_DC;
    void *      m_pDibBits;
	 
	
	
	//put any local subs or variables here
	

};

	
/////////////////////
// DllRegisterServer
/////////////////////
STDAPI DllRegisterServer()
{
    return AMovieDllRegisterServer2( TRUE );
}

////////////////////////
// DllUnregisterServer
////////////////////////
STDAPI DllUnregisterServer()
{
    return AMovieDllRegisterServer2( FALSE );
}


AM_MEDIA_TYPE *pMediaType;
VIDEOINFOHEADER *pvi;

#define TRANSFORM_NAME L"[!output PROJECT_NAME] Filter"

const AMOVIESETUP_FILTER sud[!output PROJECT_NAME] =
{ &CLSID_[!output PROJECT_NAME]              // clsID
, TRANSFORM_NAME                    // strName
, MERIT_DO_NOT_USE                  // dwMerit
, 0                                 // nPins
, NULL};                       // lpPin

// Needed for the CreateInstance mechanism
CFactoryTemplate g_Templates[]=
    {   
		{ TRANSFORM_NAME
        , &CLSID_[!output PROJECT_NAME]
        , C[!output PROJECT_NAME]::CreateInstance
        , NULL
        , &sud[!output PROJECT_NAME]
		}
    };
int g_cTemplates = sizeof(g_Templates)/sizeof(g_Templates[0]);




///////////////////////////////////////////////////////////////////////
// CreateInstance: for COM to create a [!output PROJECT_NAME] object
///////////////////////////////////////////////////////////////////////
CUnknown * WINAPI C[!output PROJECT_NAME]::CreateInstance(LPUNKNOWN punk, HRESULT *phr) {

    C[!output PROJECT_NAME] *pNewObject = new C[!output PROJECT_NAME](NAME("[!output PROJECT_NAME]"), punk, phr );
    if (pNewObject == NULL) {
        *phr = E_OUTOFMEMORY;
    }

    return pNewObject;
}

//! This function draws text onto the output image
HRESULT C[!output PROJECT_NAME]::Overlay(BYTE *pDestData,LPSTR Str)
{

    if( FrameCnt<=1||!m_DibSection )
    {
		VIDEOINFO* pVI = (VIDEOINFO*) m_pInput->CurrentMediaType( ).Format( );
          m_DibSection = CreateDIBSection(
                                        NULL,
                                        (BITMAPINFO*) &pVI->bmiHeader,
                                        DIB_RGB_COLORS,
                                        &m_pDibBits,
                                        NULL,
                                        0
                                        );
        if( !m_DibSection )
        {
            return E_FAIL;
        }

        HDC hdc = GetDC( NULL );
        m_DC = CreateCompatibleDC( hdc );
        if( !m_DC )
            return E_FAIL;

        ReleaseDC( NULL, hdc );

         SelectObject( m_DC, m_DibSection );
        
		SetTextColor(m_DC, RGB(255,0,0));

		HFONT hf;
	    static LOGFONT lf;  // structure for font information  
 
    // Get a handle to the ANSI fixed-pitch font, and copy 
    // information about the font to a LOGFONT structure. 
 
		GetObject(GetStockObject(ANSI_FIXED_FONT), sizeof(LOGFONT), 
			&lf); 
 
        lf.lfWeight = 700; 
		lf.lfItalic = 0;
		lf.lfUnderline=0;
		lf.lfHeight = -MulDiv(48, GetDeviceCaps(m_DC, LOGPIXELSY), 72);
 
    // Create the font, and then return its handle.  
 
		hf=  CreateFont(lf.lfHeight,0, 
        lf.lfEscapement, lf.lfOrientation, lf.lfWeight, 
        lf.lfItalic, lf.lfUnderline, lf.lfStrikeOut, lf.lfCharSet, 
        lf.lfOutPrecision, lf.lfClipPrecision, lf.lfQuality, 
        lf.lfPitchAndFamily, lf.lfFaceName); 
		
		SetBkMode (m_DC, TRANSPARENT);
		SetTextAlign(m_DC,TA_CENTER);
		
    }
    
    memcpy( m_pDibBits, pDestData,gSrcSize );    

    // Draw the current frame
    TCHAR szText[256];
    wsprintf( szText, TEXT("%i %s"),FrameCnt,Str);
    BOOL bWorked = TextOut(m_DC, 100, 10, szText, _tcslen( szText ) );

    // Copy our modified bitmap into the original sample buffer
    memcpy( pDestData, m_pDibBits, gSrcSize );

return NOERROR;
}
